/*
 *  Author     : Arne Vajhj
 *
 *  Programmed : february 1996
 *
 *  Purpose    : Network interface DECnet interface to QI-server
 *
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#if defined(PW) || defined(PWWIN)
#include <dn.h>
#include <socket.h>

int sd;
#endif

#ifdef VMS
#include <descrip.h>
#include <iodef.h>

long sys$assign();
long sys$qiow();
long sys$dassgn();

short chan;
short rdstat;
#endif

int net_create(char *node,char *task)
{
#if defined(PW) || defined(PWWIN)
   sd = dnet_conn(node,task,0,0,0,0,0);
   return (sd!=(-1));
#endif
#ifdef VMS
   long astat;
   char tmp[80];
   struct dsc$descriptor_s netdesc;
   sprintf(tmp,"%s::\"TASK=%s\"",node,task);
   netdesc.dsc$w_length = strlen(tmp);
   netdesc.dsc$b_class = DSC$K_CLASS_S;
   netdesc.dsc$b_dtype = DSC$K_DTYPE_T;
   netdesc.dsc$a_pointer = tmp;
   astat = sys$assign(&netdesc,&chan,0,0);
   rdstat = 1;
   return ((astat&1)==1);
#endif
}

int net_eof()
{
#if defined(PW) || defined(PWWIN)
   return dnet_eof(sd);
#endif
#ifdef VMS
   return ((rdstat&1)!=1);
#endif
}

void net_open()
{
#if defined(PW) || defined(PWWIN)
   /* not implemented */
   exit(EXIT_FAILURE);
#endif
#ifdef VMS
   $DESCRIPTOR(netdesc,"SYS$NET");
   sys$assign(&netdesc,&chan,0,0);
   rdstat = 1;
   return;
#endif
}

void net_write(char *s)
{
#if defined(PW) || defined(PWWIN)
   send(sd,s,strlen(s),0);
#endif
#ifdef VMS
   sys$qiow(0,chan,IO$_WRITEVBLK,0,0,0,s,strlen(s),0,0,0,0);
#endif
   return;
}

int net_read(char *s,int l)
{
#if defined(PW) || defined(PWWIN)
   return recv(sd,s,l,0);
#endif
#ifdef VMS
   short iosb[4];
   sys$qiow(0,chan,IO$_READVBLK,iosb,0,0,s,l,0,0,0,0);
   rdstat = iosb[0];
   if((rdstat&1)==1) {
      return iosb[1];
   } else {
      return 0;
   }
#endif
}

void net_close()
{
#if defined(PW) || defined(PWWIN)
   sclose(sd);
#endif
#ifdef VMS
   sys$dassgn(chan);
#endif
   return;
}
